--------------------------------------------------------------------------------
                              --LUA CLASSES--
--------------------------------------------------------------------------------
local offsets = {}
offsets.new = function(name, offset, byte_type)

  local self = {}
  self.name = name
  self.offset = offset
  self.byte_type = byte_type
  return self

end

local location = {}
location.new = function(name, xCoord, yCoord, zCoord, facing, mapLoc)

  local self = {}
  self.name = name
  self.xCoord = xCoord
  self.yCoord = yCoord
  self.zCoord = zCoord
  self.facing = facing
  self.mapLoc = mapLoc
  return self

end

--------------------------------------------------------------------------------
                                 --FILE IO--
--------------------------------------------------------------------------------
function file_lines(file_name)

  local lines = {}

  for line in io.lines(file_name) do
    lines[#lines + 1] = line
  end

  return lines

end

function exists(file)
  local f = io.open(file, "rb")
  if f then f:close() end
  return f ~= nil
end
--------------------------------------------------------------------------------
                          --FILL OFFSETS FROM FILE--
--------------------------------------------------------------------------------

function get_offsets(lines)

  local temp = {}

  for i = 1, #lines, 1 do
    if string.find(lines[i],"Name") then
       table.insert(temp,
       create_offset(string.sub(lines[i],string.find(lines[i],":")+1,string.len(lines[i])),
       string.sub(lines[i+1],string.find(lines[i+1],":")+1,string.len(lines[i+1])),
       string.sub(lines[i+2], string.find(lines[i+2],":")+1,string.len(lines[i+2]))))
    end
  end
  return temp

end

function create_offset(name, offset, byte_type)

  return offsets.new(name, offset, byte_type)

end


function get_locations(lines)
  local temp = {}
  for i = 1, #lines, 1 do
    if string.find(lines[i],"*") then
      table.insert(temp, create_location(lines[i]:gsub("*",""), lines[i+1], lines[i+2], lines[i+3], lines[i+4], lines[i+5]))
    end
  end
  return temp
end

--for creating location classes
function create_location(name, xCoord, yCoord, zCoord, facing, mapLoc)
  l = location.new(name, xCoord, yCoord, zCoord, facing, mapLoc)
  return l
end

--------------------------------------------------------------------------------
                                  --OTHER--
--------------------------------------------------------------------------------

function get_address(symbol)
  return string.format("%X", getAddressSafe(symbol))
end
  
function checkCemu(search)
  local windowList = getWindowList()
  for s,v in pairs(windowList) do
    for i = 1, #v, 1 do
        if string.match(v[i], search) then
            --print("Cemu version 2.0 found. Offsetting Static Address...")
            return true
        end
        --print(v[i])
    end
  end
  return false
end

--Add Compact Menu
function cycleFullCompact( sender, force )
  local state = not( compactmenuitem.Caption == 'Compact View Mode' )
  if force ~= nil then
    state = not force
  end
  compactmenuitem.Caption = state and 'Compact View Mode' or 'Full View Mode'
  getMainForm().Splitter1.Visible = state
  getMainForm().Panel4.Visible = state
  getMainForm().Panel5.Visible = state
end

function addCompactMenu()
  if compactmenualreadyexists then return end
    local parent = getMainForm().Menu.Items
    compactmenuitem = createMenuItem( parent )
    parent.add( compactmenuitem )
    compactmenuitem.Caption = 'Compact View Mode'
    compactmenuitem.OnClick = cycleFullCompact
    compactmenualreadyexists = 'yes'
end

addCompactMenu()

function checkSymbols(name)
    for p,v in pairs(symbolList) do
        if v.base ~= baseAddr then
            table.remove(symbolList, p)
        elseif name == v.symbol then
            return v
        end
    end

    return nil
end

function enable(AOB,name)
    result = checkSymbols(name)
    if result == nil then
        local scan = AOBScan(AOB)
        if scan ~= nil then 
          table.insert(symbolList, {symbol=name,address=scan[0], base=baseAddr})
          writeSymbolList()
          return scan[0]
        else
          messageDialog("INFO: AOB not found. Has the game function be initiated?",mtWarning,mbOK)
          return scan[0]
        end
    else
        return result.address
    end
end

function endianess_swap(input, output, value)
  
  value = string.pack(input, value)
  value = string.unpack(output, value)
  --print(value.."\n")

  return value
end

function safeGaurd()
  local parent = {}
  parent[1] = getMainForm().Menu.Items[3]
  parent[2] = getMainForm().Menu.Items[4]
  parent[3] = getMainForm().Menu.Items[10]
  parent[4] = getMainForm().Menu.Items[11]

  for i = 1, #parent, 1 do
      parent[i].destroy()
  end

  getMainForm().Splitter1.Visible = false
  getMainForm().Panel4.Visible = false
  getMainForm().Panel5.Visible = false
end

if exists("debug.txt")then
  debugTable = true
else
  debugTable = false
end



