function find_location(search)
  for k,v in pairs(global_locations) do
    if search == v.mapLoc then
      return v
    end
  end
  print("ERROR: Could not find location.")
  return -1
end

function find_offset(tbl)

  for k,v in pairs(global_offsets) do
    if tbl[1] == v.name then
      --print("Match found. Returning.....")
      return v
    end
  end

  return 0
end

function get_list_location(search, list)
  for k,v in pairs(list) do
    if v[1].Name == search.Name then
      return v
    elseif v[2].Name == search.Name then
      return v
    end
  end
  print("Error: Could not find search term '"..search.Name.."'")
  return -1
end

function read_pointer(loc)
  
  local pointer = readBytes(getAddressSafe(loc), 6, true)
  for i = 1,#pointer, 1 do
    if string.len(string.format("%x",pointer[i])) == 1 then
      pointer[i] = "0"..string.format("%x",pointer[i])
    else
        pointer[i] = string.format("%x",pointer[i])
    end
  end
  pointer = tonumber(table.concat(pointer),16)
  pointer = string.pack(">I6", pointer)
  pointer = string.unpack("I6", pointer)

  return pointer
end

function select_map_item_onClick(sender)
  --print(sender.Name)
  init()
  local temp = {}
  --print(sender.name)

  if current_selected == nil then
    current_selected = get_list_location(sender, picture_list)
    current_selected[1].visible = not current_selected[1].visible
    current_selected[2].visible = not current_selected[2].visible
  elseif sender.Name == current_selected[2].Name then
    current_selected[1].visible = not current_selected[1].visible
    current_selected[2].visible = not current_selected[2].visible
    current_selected = nil
    teleports.map_select_lbl.caption = "Selected: ???"
    teleports.unlock_map.enabled = false
    teleports.lock_map.enabled = false
  else
    current_selected[1].visible = not current_selected[1].visible
    current_selected[2].visible = not current_selected[2].visible
    current_selected = get_list_location(sender, picture_list)
    current_selected[1].visible = not current_selected[1].visible
    current_selected[2].visible = not current_selected[2].visible
  end

  if current_selected ~= nil then
    temp = find_location(current_selected[1].name)
    if temp ~= -1 then
      teleports.map_select_lbl.caption = "Selected: "..temp.name.."["..temp.mapLoc.."]"
    end

    local mapLoc = find_offset({temp.mapLoc,temp.name})
    if mapLoc ~= 0 then
        teleports.unlock_map.caption = "Unlock ".. mapLoc.name
        teleports.lock_map.caption = "Lock ".. mapLoc.name
        if readByte(tonumber(baseAddr,16) + tonumber(mapLoc.offset,16)) > 0 then
          teleports.unlock_map.enabled = false
          teleports.lock_map.enabled = true
        else
          teleports.unlock_map.enabled = true
          teleports.lock_map.enabled = false
        end
    else
        messageDialog("Selected Location '["..temp.mapLoc.."]' could not be found in Offset file.", mtInfo, mbOK)
    end
  end

  --[[if current_selected == nil then
    --print("Was Nil.")
    current_selected = get_list_location(sender, picture_list)
    current_selected[2].visible = true
    sender.visible = false
    temp = find_location(current_selected[1].name)
    if temp ~= -1 then
      teleports.map_select_lbl.caption = "Selected: "..temp.name.."["..temp.mapLoc.."]"
    end
  elseif current_selected[1].name == sender.name or current_selected[2].name  == sender.name then
    return
  else
    current_selected[2].visible = false
    current_selected[1].visible = true
    current_selected = get_list_location(sender, picture_list)
    current_selected[2].visible = true
    current_selected[1].visible = false
  end--]]



  --print(current_selected[1].name)
  --print(temp.mapLoc)
end

function tp_onClick(sender)

  if current_selected == nil then
    messageDialog("Select a map loction to be able to use '"..sender.Caption.."'", mtInfo, mbOK)
    return
  end

  local pointer = read_pointer("pBoat")
  local base = getAddressSafe("static")
  local loc = find_location(current_selected[1].name)
  local x = base + tonumber(find_offset({"X"}).offset, 16)
  local y = base + tonumber(find_offset({"Y"}).offset, 16)
  local z = base +tonumber(find_offset({"Z"}).offset, 16)
  local facing = base + tonumber(find_offset({"Facing"}).offset,16)


  if pointer then
    if sender.name == "tp_boat" then
      writeFloat(pointer,endianess_swap(">f", "f", tonumber(loc.xCoord)))
      writeFloat(pointer+8,endianess_swap(">f", "f", tonumber(loc.yCoord)))
      writeFloat(pointer+4,endianess_swap(">f", "f", tonumber(loc.zCoord)))
      writeSmallInteger(pointer+0x16,endianess_swap(">H", "H", tonumber(loc.facing)))
    else
      local list = getAddressList().getMemoryRecordByDescription("Teleport Link")
      list.active = true
    end
  else
    print("ERROR: Pointer for Boat Coordinates not found.")
  end
end

function tp_to_boat_onClick(sender)

  local list = getAddressList().getMemoryRecordByDescription("Teleport into Boat")
  list.active = true

end

function wait(time, z, val)
  sleep(time)
  writeFloat(z, endianess_swap(">f", "f", val))
end

function map_region_unlocker()
  local mapLoc = find_offset({current_selected[1].name})
  if mapLoc ~= 0 then
     writeByte(tonumber(baseAddr,16) + tonumber(mapLoc.offset,16), 1)
     teleports.lock_map.enabled = true
     teleports.unlock_map.enabled = false
  else
     messageDialog("Selected Location '["..temp.mapLoc.."]' could not be found in Offset file.", mtInfo, mbOK)
  end
end

function map_region_locker()
  local mapLoc = find_offset({current_selected[1].name})
  if mapLoc ~= 0 then
    writeByte(tonumber(baseAddr,16) + tonumber(mapLoc.offset,16), 0)
    teleports.unlock_map.enabled = true
    teleports.lock_map.enabled = false
  else
     messageDialog("Selected Location '["..temp.mapLoc.."]' could not be found in Offset file.", mtInfo, mbOK)
  end
end
